import stan
import arviz as az
import pickle
import pandas as pd

pd.set_option('display.max_columns', None)

fout = open('Output.txt', 'w')

K = int(input('K = '))
s = input('Data for Noise = ')
Data_Noise = []
for v in s.split():
    Data_Noise.append(int(v))
s = input('Data for Signal = ')
Data_Signal = []
for v in s.split():
    Data_Signal.append(int(v))

with open('noise.pkl', 'wb') as f:
    pickle.dump(Data_Noise, f)
with open('signal.pkl', 'wb') as f:
    pickle.dump(Data_Signal, f)

fout.write('\nData for Noise:\n')
fout.write('    {}\n'.format(Data_Noise))
fout.write('\nData for Signal:\n')
fout.write('    {}'.format(Data_Signal))

Data = {'K': K, 'Freq_Noise': Data_Noise, 'Freq_Signal': Data_Signal}
with open('YN_rating.stan', 'r') as f:
    pm = stan.build(f.read(), data = Data)

fit = pm.sample(num_samples = 10000) 

print('fit =\n', fit)

infrnc_d = az.from_pystan(posterior = fit, posterior_model = pm )
print('\nSummary =\n', az.summary(infrnc_d))

with open('infrnc_d.pkl', 'wb') as f:
    pickle.dump(infrnc_d, f)

d_frame = fit.to_frame()
print(d_frame.keys())
with open('d_frame.pkl', 'wb') as f:
    pickle.dump(d_frame, f)

fout.close()
print('Output.txt was saved.')
